// SWIG file Interval.i
// Author : $LastChangedBy: schueller $
// Date : $LastChangedDate: 2011-07-06 12:03:57 +0200 (Wed, 06 Jul 2011) $
// Id : $Id: Interval.i 1991 2011-07-06 10:03:57Z schueller $

%{
#include "PythonWrappingFunctions.hxx"
#include "Interval.hxx"
%}

// class UnsignedLongCollection is defined in wrapper_module.i (module wrapper)
%pythoncode %{
class BoolCollection(wrapper.UnsignedLongCollection): pass
%}

%rename(__eq__) OpenTURNS::Base::Type::Interval::operator==(const Interval & rhs) const;

%include Interval.hxx
namespace OpenTURNS { namespace Base { namespace Type {

%extend Interval {

//  Interval(PyObject * pyObj1, PyObject * pyObj2)
//  {
//    OpenTURNS::check<OpenTURNS::_PySequence_>( pyObj1 );
//    OpenTURNS::check<OpenTURNS::_PySequence_>( pyObj2 );
//    return new OpenTURNS::Base::Type::Interval( OpenTURNS::convert<OpenTURNS::_PySequence_,OpenTURNS::Base::Type::NumericalPoint>( pyObj1 ),
//	                                        OpenTURNS::convert<OpenTURNS::_PySequence_,OpenTURNS::Base::Type::NumericalPoint>( pyObj2 ) );
//  }

  Interval(PyObject * pyObj1, PyObject * pyObj2, PyObject * pyObj3, PyObject * pyObj4)
  {
    OpenTURNS::check<OpenTURNS::_PySequence_>( pyObj1 );
    OpenTURNS::check<OpenTURNS::_PySequence_>( pyObj2 );
    OpenTURNS::check<OpenTURNS::_PySequence_>( pyObj3 );
    OpenTURNS::check<OpenTURNS::_PySequence_>( pyObj4 );
    OpenTURNS::Pointer<OpenTURNS::Base::Type::Collection<OpenTURNS::UnsignedLong> > ptr3 = OpenTURNS::buildCollectionFromPySequence<OpenTURNS::UnsignedLong>( pyObj3 );
    OpenTURNS::Pointer<OpenTURNS::Base::Type::Collection<OpenTURNS::UnsignedLong> > ptr4 = OpenTURNS::buildCollectionFromPySequence<OpenTURNS::UnsignedLong>( pyObj4 );
    return new OpenTURNS::Base::Type::Interval( OpenTURNS::convert<OpenTURNS::_PySequence_,OpenTURNS::Base::Type::NumericalPoint>( pyObj1 ),
                                                OpenTURNS::convert<OpenTURNS::_PySequence_,OpenTURNS::Base::Type::NumericalPoint>( pyObj2 ),
                                                *ptr3,
	                                        *ptr4 );
  }

}

}}}

namespace OpenTURNS { namespace Base { namespace Type { %extend Interval { Interval(const Interval & other) { return new OpenTURNS::Base::Type::Interval(other); } } }}}
