// SWIG file RandomGenerator.i
// Author : $LastChangedBy: dutka $
// Date : $LastChangedDate: 2010-09-14 16:35:33 +0200 (Tue, 14 Sep 2010) $
// Id : $Id: RandomGenerator.i 1617 2010-09-14 14:35:33Z dutka $

%{
#include "RandomGenerator.hxx"
%}

%include RandomGenerator.hxx

namespace OpenTURNS { namespace Base { namespace Stat {
struct RandomGeneratorState {
  OpenTURNS::Base::Type::Collection<OpenTURNS::UnsignedLong> state_;
  UnsignedLong index_;
  RandomGeneratorState() : state_(0), index_(0) {}
  RandomGeneratorState(const OpenTURNS::Base::Type::Collection<OpenTURNS::UnsignedLong> & state, const UnsignedLong index) : state_(state), index_(index) {}
  ~RandomGeneratorState() {}
}; /* end struct RandomGeneratorState */

%extend RandomGeneratorState {
  const String __repr__() const
  {
    return OT::OSS(true) << "RandomGenerator::State("
                         << self->state_ << ", "
                         << self->index_ << ")";
  }
  const String __str__(const String & offset = "") const
  {
    return OT::OSS(false) << "RandomGenerator::State("
                          << self->state_ << ", "
                          << self->index_ << ")";
  }
}

}}}

namespace OpenTURNS { namespace Base { namespace Stat { %extend RandomGenerator { RandomGenerator(const RandomGenerator & other) { return new OpenTURNS::Base::Stat::RandomGenerator(other); } } }}}
