// SWIG file typ_module.i
// Author : $LastChangedBy: schueller $
// Date : $LastChangedDate: 2011-07-06 12:03:57 +0200 (Wed, 06 Jul 2011) $
// Id : $Id: typ_module.i 1991 2011-07-06 10:03:57Z schueller $

%module(package="openturns", docstring="Internal data types.") typ
%feature("autodoc","1");

%{
#include "OTconfig.hxx"
#include "OTCommon.hxx"
#include "OTType.hxx"
%}

%include typemaps.i
%include OTtypes.i
%include OTexceptions.i
%include std_vector.i

/* Base/Common */
%import common_module.i

/* Wrapper */
%import wrapper_module.i
%import BaseWrapperTemplateDefs.i

/* Base/Type */
%include PersistentCollection.i
%include DescriptionImplementation.i
%include Description.i
%include NumericalPoint.i
%include NumericalPointWithDescription.i
%include Indices.i
%include Interval.i
%include MatrixImplementation.i
%include Matrix.i
%include SquareMatrix.i
%include SymmetricMatrix.i
%include TensorImplementation.i
%include Tensor.i
%include SymmetricTensor.i
%include Cache.i

/* At last we include template definitions */
%include BaseTypTemplateDefs.i
